#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <strings.h>
#include "filelist.h"
#include "fits.h"
#include "gtk.h"

//~ GList *files_list = NULL;
//~ GList *list_current = NULL;
//~ gint list_length = 0;
//~ GList *list_end = NULL;


//~ void prnt(gpointer data){
	//~ printf("entry: %s\n", (gchar*)data);
//~ }

/*
 *   , type     :
 *		CURRENT		-  
 *		FIRST		-  
 *		LAST		-  
 *		PREVIOUS	-  
 *		NEXT		-  
 */
gchar *get_filename(guchar type, Window *window){
	DBG("length of list = %d", window->files.list_length);
	if(window->files.list_length < 1) return NULL;
	if(!window->files.list_current){
		DBG("No current file. WTF?");
		return NULL;
	}
	//~ g_list_foreach(window->files.files_list, (GFunc)prnt, NULL);
	switch(type){
		case FIRST:
			if(window->files.list_current == window->files.files_list){
				DBG("1st or only file");
				return NULL; //        ,   
			}
			window->files.list_current = window->files.files_list;
		break;
		case LAST:
			if(window->files.list_length < 2 ||
				window->files.list_current == window->files.list_end){
				DBG("last or only file");
				return NULL;
			}
			window->files.list_current = window->files.list_end;
		break;
		case PREVIOUS:
			if(!window->files.list_current->prev){
				DBG("1st file");
				return NULL;
			}
			window->files.list_current = window->files.list_current->prev;
		break;
		case NEXT:
			if(!window->files.list_current->next){
				DBG("last file");
				return NULL;
			}
			window->files.list_current = window->files.list_current->next;
		break;
		default: // current
		break;
	}
	if(!window->files.list_current || !window->files.list_current->data){
		DBG("no current file? WTF?");
		return NULL;
	}
	DBG("change filename: %s\n\n", (gchar*)window->files.list_current->data);
	return (gchar*)window->files.list_current->data;
}

gboolean get_ext(gchar *filename){
	gchar *basename, *ext;
	basename = strrchr(filename, '/');
	if(!basename) basename = filename;
	else basename++;
	ext = strrchr(basename, '.');
	if(!ext) return FALSE;
	else ext++;
	//DBG("basename = %s; ext = %s", basename, ext);
	if(strcasecmp(ext, "fts") == 0 || strcasecmp(ext, "fit") == 0 ||
		strcasecmp(ext, "fits") == 0) return TRUE;
	return FALSE;
}

//    
gboolean is_loadable(gchar *filename){
    if(!Global->add_all){ //      
		if(!get_ext(filename)) //      
			return FALSE;
	}
    return guess_fits(filename);
}

//~ void pppr(){
	//~ GList *list = window->files.files_list;
	//~ if(!list) return;
	//~ while((list = list->next)){
		//~ printf("next list data: %s\n", (char*)list->data);
	//~ };
//~ }
gint add_file_to_list(gchar *filename, Window *window){
	if(is_loadable(filename)){
		DBG("File %s is FITS file\n", filename);
		window->files.files_list = g_list_prepend(window->files.files_list, (gpointer)filename);
		window->files.list_length++;
		//DBG("list length = %d", window->files.list_length);
		if(window->files.list_length == 1)
			window->files.list_end = window->files.files_list;
		//else
		//	window->files.list_end = g_list_last(window->files.files_list);
			//window->files.list_end = window->files.list_end->next;
		return 1;
	}
	return 0;
}

/*
 *        
 *		filename -  ,       . 
 * 		 -  
 */
gint fill_filelist(gchar *filename, Window *window){
	gint nb_inserted = 0;
	GDir *dir;
	GError *err = NULL;
	const gchar *dir_entry;
	gchar *dirname = g_path_get_dirname(filename);
	DBG("Open directory %s", dirname);
	dir = g_dir_open(dirname, 0, &err);
	if(dir == NULL){
		g_err(err->message);
		g_error_free(err);
		return 0;
	}
	if(window->files.files_list){ //  ,     
		g_list_foreach(window->files.files_list, (GFunc)free, NULL);
		g_list_free(window->files.files_list);
		window->files.list_length = 0;
		window->files.files_list = NULL;
	}
	while((dir_entry = g_dir_read_name(dir))){
		gchar *full_path = g_build_filename(dirname, dir_entry, NULL);
		if(!g_file_test(full_path, G_FILE_TEST_IS_DIR)){
			//DBG("read file %s (%s)", dir_entry, full_path);
			nb_inserted += add_file_to_list(full_path, window);
		}
		//g_free(full_path);
	}
	g_dir_close(dir);
	g_free(dirname);
	window->files.files_list = g_list_sort(window->files.files_list, (GCompareFunc)strcmp);
	DBG("\nSort %d items\n", nb_inserted);
	//~ pppr();
	//g_list_foreach(window->files.files_list, (GFunc)prnt, NULL);
	window->files.list_end = g_list_last(window->files.files_list);
	window->files.list_current = g_list_find_custom(window->files.files_list, filename,(GCompareFunc)strcmp);
	//~ place_first = g_list_find_custom(window->files.files_list, filename, strcmp);
	//~ if(place_first && place_first->prev){
		//~ place_first->prev->next = place_first->next;
		//~ if(place_first->next)
			//~ place_first->next->prev = place_first->prev;
		//~ place_first->prev = NULL;
		//~ place_first->next = window->files.files_list;
		//~ window->files.files_list->prev = place_first;
		//~ window->files.files_list = place_first;
	//~ }
	return nb_inserted;
}

