//      fitsview.c -   
//
//      Copyright 2011 Edward V. Emelianoff <eddy@sao.ru>
//
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.
#include <sys/time.h> //  dtime
#include <libgen.h>   //  basename
#include "fitsview.h"
#include "fits.h"
#include "gtk.h"
#include "opengl.h"
#include "filelist.h"

Global_context *Global;

//   
void *init_struct(int size){
	int8_t *ptr = calloc(1, size);
	return (void*) ptr;
}
//  
void *copy_struct(void *src, int size){
	int8_t *ptr = calloc(1, size);
	memcpy(ptr, src, size);
	return (void*)ptr;
}

/*  ,     .  ( ),
 *   -  
 */
double dtime(){
	double t;
	struct timeval tv;
	gettimeofday(&tv, NULL);
	t = tv.tv_sec + ((double)tv.tv_usec)/1e6;
	return t;
}

int main(int argc, char *argv[]){
	gchar *filename = NULL, *path, *str;
#ifdef CUDA_FOUND
	DBG("CUDA found");
#else
	DBG("CUDA not found, using CPU instead");
#endif
	bindtextdomain(GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
	textdomain(GETTEXT_PACKAGE);
	INIT(Global, Global_context);
	init_main_window(&argc, &argv);
	getGLinfo(mainWindow->drawingArea);
	setlocale(LC_NUMERIC, "C"); //   strto[df]   
	//    
	mainWindow->context->visualMode = SHOW_ALL;
	mainWindow->image->data = NULL;
	if(argc > 1){
		str = basename(argv[1]);
		path = get_current_dir_name();
		filename = g_strdup_printf("%s/%s", path, str);
		free(path);
		fill_filelist(filename, mainWindow);
		change_image(filename, mainWindow);
		g_free(filename);
	}
		/*if(!readfits(filename, image)){
			g_err(_("Can't read fits file"));
			free(image->data);
			image->data = NULL;
		}*/
//	if(image->data){
	gen_texture(mainWindow->image, mainWindow, FALSE);
//	}
	gtk_main();
	return 0;
}
