#ifndef _GTK_H_
#define _GTK_H_
#include "fitsview.h"
#include "spots.h" //   Coordinates
#define EVENT_METHOD(i, x) GTK_WIDGET_GET_CLASS(i)->x

#define CH_WIN_TITLE(wndw, ...)	do{				\
	gchar *title = g_strdup_printf(__VA_ARGS__);	\
	gtk_window_set_title(GTK_WINDOW(wndw->window), title);\
	g_free(title);									\
	}while(0)

//      
#define SBAR_MAX 4
//    
enum{
	 StatusText			//    
	,StatusState		//  
	,StatusCoords		// 
	,StatusAdd		// - 
};

typedef struct{
	GLuint tex;		//  
	GLuint w;		//  !!! w  h , ..     !!!
	GLuint h;		//   
} TEXTURE;

typedef struct{
	double x;
	double y;
} XY;

//       
typedef struct{
	gint list_length;
	GList *files_list;
	GList *list_current;
	GList *list_end;
} FITSlist;

// - 
struct _Window{
	int id;						// : MAIN_WINDOW, GRAPH_WINDOW, OPENGL_WINDOW
	GtkWidget *window;			//    
	Context *context;			//   
	struct _Window *parent;		//   (NULL  )
	struct _Window *graphWindow;//     (  - NULL)
	GtkWidget *drawingArea;		//  
	GtkWidget *hRule;			// 
	GtkWidget *vRule;
	GtkEntry *SBars[SBAR_MAX];	//      
	guint statusBlocks;			// - 
	IMAGE *image;				//  
	IMAGE *image_transformed;	//    
	TEXTURE *texture;			//    VBO
	GtkRadioAction *LinLogMenu[2]; //     " "
	double Zoom;				// 
	double Daspect;				//    
	XY move;					//  
	XY mouse;					// .x, .y -      
	GLfloat Xangle;				//     X  Z
	GLfloat Zangle;
	FITSlist files;				//       
};
typedef struct _Window Window;
//  
enum{
	MAIN_WINDOW,
	GRAPH_WINDOW,
	OPENGL_WINDOW,
	GL3D_WINDOW
};

extern Window *mainWindow;

void change_image(gchar *filename, Window *window);
void init_main_window(int *argc, char ***argv);
Window *init_window(Window *parent, int winId);
void destroy_window(Window* window);
void run_modal_window(GtkWindow *w, Window *parent);
gint run_modal_dialog(GtkDialog *dialog, Window *parent);
void g_err(gchar *text);
void set_Drulers(double x0, double y0, double xm, double ym, Window *window);
void set_Grulers(double y0, double xm, double ym, Window *window);
void show_histogram(Window *window);
void set_status_text(guint barName, gchar *text, Window *window);
void refresh_state(Window *window);
gchar *get_open_filename(Window *window);
#endif // _GTK_H_
