#ifndef _SPOTS_H_
#define _SPOTS_H_
#include "fitsview.h"

#ifndef LEPTONICA_FOUND
	#define LEPTERR g_err(_("Install Leptonica library and remake sources for this functions"))
	typedef struct{double x; double y; double w; double h;} BOX;
	typedef void* PIX;
#else
	#include <allheaders.h>  //  
#endif // LEPTONICA_FOUND


/*    +  
 *     box-,  
 *      ,  - 
 *  (x  y -    , rx  ry -
 *      */
typedef struct{
	double x;
	double y;	// - 
	double rx;
	double ry;	//   
} Coordinates;

//  
typedef struct{
	BOX	box;		//  
	Coordinates c;	//        ,   
	double r;		//  -    
	double phi;		//   ( OX   )
	double xC;		//         
	double yC;
	int id;			// ,   ..
} Spot;

//  
typedef struct{
	int size;	//  
	int n;		//    
	int memflag;// BY_COPY  BY_PTR -    free
	Spot **spot;//    
} Spots;

Spots* spots_alloc(int n);
Spot* spots_add(Spots *spots, Spot *spot, int copy);
enum {	//    spots_add
	BY_COPY,	//  spot
	BY_PTR		//     spot
};
void spots_free(Spots **spots);
void sort_spots(Spots *spots);

extern Spots *spots;
extern double AxisX, AxisY;

#endif // _SPOTS_H_
